yaf框架目录组织

0. 生成一个新的项目
   - 下载 ``` deploy_init.sh ``` 运行脚本文件，到本地项目空间下
   - 运行  ``` sh deploy_init.sh project_name ``` 则在对应的目录下生成project_name的文件夹
   - 注 : 该项目是一个空的git,需根据项目自行添加
1. php.ini 的配置如下
```
[yaf]
extension=yaf.so
yaf.environ=dev
yaf.use_namespace=1
yaf.use_spl_autoload=1
yaconf.directory=/Users/admin/works/php/yaconf # 这里是你本地开发所用的yaconf路径
```
2. 配置 Nginx 的 Rewrite

```
location / {    # 因所有地址都以/开头，所以该规则将匹配到所有请求，但正则和最长字符串会优先匹配
	if (!-e $request_filename) {
 	   rewrite ^/(.*) /index.php?$1 last;
	}
}
location ~ \.php$ {   #匹配所有以.php结尾的文件
    fastcgi_index index.php;
    include fastcgi.conf;   
    fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
    fastcgi_param YIDIAN_LOCAL_IP '127.0.0.1';
    fastcgi_pass 127.0.0.1:9000;
}

```
3. composer update
4. 浏览器访问 http://your_domain/test/test/index
5. 命令行执行 php cli.php test index "a=1&b=2"
6. 如果是内部使用的方法文件，请在文件前添加注释，如下:

```
    <?php
    /**
     * @mark FOR_INTERNAL_USE_ONLY
     */
     class Test{
        public function TestAction()
        {
        }
     }
```

- 项目依赖项包括 yaconf，php_utils, php_services三个项目，
- composer update 有依赖更新要及时执行
- yaconf统一管理，不要在自己的项目中建yaconf目录
- protobuf3的定义文件统一放到yaconf中管理
