<?php


namespace Validate;


/**
 * Class GoodsAddValidate
 *
 * @package Validate
 */
class GoodsAddValidate extends BaseValidate
{
    protected $rule = [
        'category_1_id' => 'require',
        'category_2_id' => 'require',
        'goods_name' => 'require',
        'desc_pic_url' => 'require',
        'expiration_time' => 'require',
        'rule_desc' => 'require',
        'price' => 'require',
        'inventory' => 'require',
        'publish_user_id' => 'require',
        'sub_shop_ids' => 'require',
    ];

    protected $message = [
        'category_1_id' => '请选择所属类目',
        'category_2_id' => '请选择所属类目',
        'goods_name' => '商品名称不能为空',
        'desc_pic_url' => '请上传商品图片',
        'expiration_time' => '请填写到期时间',
        'rule_desc' => '请填写使用规则',
        'price' => '请填写售价',
        'inventory' => '请填写库存',
        'publish_user_id' => 'user_id 不能为空',
        'sub_shop_ids' => '门店id不能为空',
    ];
}