#!/usr/bin/env bash

# Start commands for each container, one cmd a line
START_CMDS="
cd /home/services && ${start_cmd}
"

QA_PRE_START_CMD="
"

# Container names for each container, one name a line, same order with $start_cmds
CONTAINER_NAMES="
api-${env}-${domain_prefix}
"

# Port maps for each container, one map a line, same order with $start_cmds
DOCKER_PORT_MAPS="
${TARGET_PORT}:9000
"

# This is for changing container name, remove old containers when deploy new one
OLD_CONTAINER_NAMES="
api-${env}-${domain_prefix}
"

# Volumn maps for each container, one map a line, same order with $start_cmds
DOCKER_VOLUMN_MAPS="
/home/worker/_logs/api-${env}-${domain_prefix}:/home/services/api.go2yd.com/logs
"

# Other docker run options
DOCKER_RUN_OPTIONS="--cap-add SYS_PTRACE --restart=always --privileged"
# Image name
IMAGE_NAME="docker2.yidian.com:5000/publish/${release_job}-${release_number}-image"
# This is for stopping container, kill sepicify process inside the container before 'docker stop' and 'docker rm'
DOCKER_PRESTOP_CMD='mv /var/lib/logrotate.status /home/services/api.go2yd.com/logs/logrotate.status'
# Service port for apitest
SERVICE_PORT=${TARGET_PORT}
# Service port inside container
ORIGIN_SERVICE_PORT="9000"
